Index: src/embeddedLua/CMakeLists.txt
===================================================================
--- src/embeddedLua/CMakeLists.txt	(revision 74617)
+++ src/embeddedLua/CMakeLists.txt	(working copy)
@@ -40,6 +40,7 @@
     halfspace.cpp
     initbrlcad.cpp
     luadatabase.cpp
+    sphere.cpp
     vector3d.cpp
     writestring.cpp
     ../other/lua/src/lapi.c
Index: src/embeddedLua/initbrlcad.cpp
===================================================================
--- src/embeddedLua/initbrlcad.cpp	(revision 74617)
+++ src/embeddedLua/initbrlcad.cpp	(working copy)
@@ -29,6 +29,7 @@
  */
 
 #include "halfspace.h"
+#include "sphere.h"
 #include "luadatabase.h"
 #include "initbrlcad.h"
 
@@ -39,6 +40,7 @@
     BRLCAD::Database& database
 ) {
     InitHalfspace(luaState);
+    InitSphere(luaState);
 
     InitDatabase(luaState, database);
 }
Index: src/embeddedLua/sphere.cpp
===================================================================
--- src/embeddedLua/sphere.cpp	(nonexistent)
+++ src/embeddedLua/sphere.cpp	(working copy)
@@ -0,0 +1,279 @@
+/*                         SPHERE . CPP
+ * BRL-CAD
+ *
+ * Copyright (c) 2019 United States Government as represented by
+ * the U.S. Army Research Laboratory.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in all
+ * copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+ * SOFTWARE.
+ */
+/** @file sphere.cpp
+ *
+ *  BRL-CAD embedded lua script:
+ *      BRLCAD::Sphere functions
+ */
+
+#include <cassert>
+
+#include "objectbase.h"
+#include "vector3d.h"
+#include "sphere.h"
+
+
+struct ScriptSphere {
+    BRLCAD::Sphere* object;
+    bool               own;
+};
+
+
+static BRLCAD::Sphere& GetSphere
+(
+    lua_State* luaState,
+    int        narg
+) {
+    BRLCAD::Sphere* object = TestSphere(luaState, narg);
+    assert(object != 0);
+
+    return *object;
+}
+
+
+static int CreateSphere
+(
+    lua_State* luaState
+) {
+    BRLCAD::Sphere* ret = 0;
+
+    if (lua_gettop(luaState) > 0) {
+        BRLCAD::Sphere* original = TestSphere(luaState, 1);
+
+        if (original != 0)
+            ret = new BRLCAD::Sphere(*original);
+    }
+
+    if (ret == 0)
+        ret = new BRLCAD::Sphere();
+
+    return PushSphere(luaState, ret, true);
+}
+
+
+static int Destruct
+(
+    lua_State* luaState
+) {
+    ScriptSphere* scriptObject = static_cast<ScriptSphere*>(luaL_testudata(luaState, 1, "BRLCAD.Sphere"));
+
+    if ((scriptObject != 0) && (scriptObject->object != 0) && scriptObject->own)
+        scriptObject->object->Destroy();
+
+    return 0;
+}
+
+
+static int Center
+(
+    lua_State* luaState
+) {
+    BRLCAD::Sphere& object = GetSphere(luaState, 1);
+    BRLCAD::Vector3D   value  = GetVector3D(luaState, 1);
+
+    PushVector3D(luaState, value);
+
+    return 1;
+}
+
+
+static int SetCenter
+(
+    lua_State* luaState
+) {
+    BRLCAD::Sphere&  object = GetSphere(luaState, 1);
+    BRLCAD::Vector3D normal = GetVector3D(luaState, 1);
+
+    object.SetCenter(normal);
+
+    return 0;
+}
+
+
+static int Radius
+(
+    lua_State* luaState
+) {
+    BRLCAD::Sphere& object = GetSphere(luaState, 1);
+
+    lua_pushnumber(luaState, object.Radius());
+
+    return 1;
+}
+
+
+static int SetRadius
+(
+    lua_State* luaState
+) {
+    BRLCAD::Sphere& object = GetSphere(luaState, 1);
+    double          distance = luaL_checknumber(luaState, 2);
+
+    object.SetRadius(distance);
+
+    return 0;
+}
+
+
+static int Set
+(
+    lua_State* luaState
+) {
+    BRLCAD::Sphere&  object = GetSphere(luaState, 1);
+    BRLCAD::Vector3D center = GetVector3D(luaState, 1);
+    double           radius = luaL_checknumber(luaState, 2);
+
+    object.Set(center, radius);
+
+    return 0;
+}
+
+
+static int ClassName
+(
+    lua_State* luaState
+) {
+    lua_pushstring(luaState, BRLCAD::Sphere::ClassName());
+
+    return 1;
+}
+
+
+static BRLCAD::Object& GetObject
+(
+    lua_State* luaState,
+    int        narg
+) {
+    return GetSphere(luaState, narg);
+}
+
+
+static void GetSphereMetatable
+(
+     lua_State* luaState
+) {
+    lua_getfield(luaState, LUA_REGISTRYINDEX, "BRLCAD.Sphere");
+
+    if (!lua_istable(luaState, -1)) {
+        lua_pop(luaState, 1);
+        luaL_newmetatable(luaState, "BRLCAD.Sphere");
+
+        lua_pushvalue(luaState, -1);
+        lua_setfield(luaState, -2, "__index");
+
+        lua_pushstring(luaState, "__gc");
+        lua_pushcfunction(luaState, &Destruct);
+        lua_settable(luaState, -3);
+
+        PushObjectMetatable<GetObject>(luaState);
+
+        lua_pushstring(luaState, "Center");
+        lua_pushcfunction(luaState, &Center);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "SetCenter");
+        lua_pushcfunction(luaState, &SetCenter);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "Radius");
+        lua_pushcfunction(luaState, &Radius);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "SetRadius");
+        lua_pushcfunction(luaState, &SetRadius);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "Set");
+        lua_pushcfunction(luaState, &Set);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "Clone");
+        lua_pushcfunction(luaState, &CreateSphere);
+        lua_settable(luaState, -3);
+
+        lua_pushstring(luaState, "ClassName");
+        lua_pushcfunction(luaState, &ClassName);
+        lua_settable(luaState, -3);
+    }
+}
+
+
+void InitSphere
+(
+    lua_State* luaState
+) {
+    lua_getglobal(luaState, "BRLCAD");
+
+    if (!lua_istable(luaState, -1)) {
+        lua_pop(luaState, 1);
+        lua_newtable(luaState);
+        lua_setglobal(luaState, "BRLCAD");
+        lua_getglobal(luaState, "BRLCAD");
+    }
+
+    lua_pushcfunction(luaState, &CreateSphere);
+    lua_setfield(luaState, -2, "Sphere");
+
+    lua_pop(luaState, 1);
+}
+
+
+int PushSphere
+(
+    lua_State*         luaState,
+    BRLCAD::Sphere* object,
+    bool               takeOwnership
+) {
+    int ret = 0;
+
+    if (object != 0) {
+        ScriptSphere* scriptObject = static_cast<ScriptSphere*>(lua_newuserdata(luaState, sizeof(ScriptSphere)));
+
+        scriptObject->object = object;
+        scriptObject->own    = takeOwnership;
+
+        GetSphereMetatable(luaState);
+        lua_setmetatable(luaState, -2);
+
+        ret = 1;
+    }
+
+    return ret;
+}
+
+
+BRLCAD::Sphere* TestSphere
+(
+    lua_State* luaState,
+    int        narg
+) {
+    BRLCAD::Sphere* ret          = 0;
+    ScriptSphere*   scriptObject = static_cast<ScriptSphere*>(luaL_testudata(luaState, narg, "BRLCAD.Sphere"));
+
+    if (scriptObject != 0)
+        ret = scriptObject->object;
+
+    return ret;
+}
Index: src/embeddedLua/sphere.h
===================================================================
--- src/embeddedLua/sphere.h	(nonexistent)
+++ src/embeddedLua/sphere.h	(working copy)
@@ -0,0 +1,60 @@
+/*                         SPHERE . H
+ * BRL-CAD
+ *
+ * Copyright (c) 2019 United States Government as represented by
+ * the U.S. Army Research Laboratory.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in all
+ * copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+ * SOFTWARE.
+ */
+/** @file sphere.h
+ *
+ *  BRL-CAD embedded lua script:
+ *      BRLCAD::Sphere functions
+ */
+
+#ifndef SPHERE_INCLUDED
+#define SPHERE_INCLUDED
+
+#include "lua.hpp"
+
+#include "brlcad/Sphere.h"
+
+
+void InitSphere
+(
+    lua_State* luaState
+);
+
+
+int PushSphere
+(
+    lua_State*         luaState,
+    BRLCAD::Sphere* object,
+    bool               takeOwnership
+);
+
+
+BRLCAD::Sphere* TestSphere
+(
+    lua_State* luaState,
+    int        narg
+);
+
+
+#endif // SPHERE_INCLUDED
